# harvester/db/models.py

from sqlalchemy import Column, Integer, String, DateTime
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()


class Proxy(Base):
    __tablename__ = 'proxies'

    id = Column(Integer, primary_key=True)
    host = Column(String, nullable=False)
    port = Column(Integer, nullable=False)
    asn = Column(String)
    egress_ip = Column(String)
    egress_asn = Column(String)
    date_added = Column(DateTime, nullable=False)
    date_validated = Column(DateTime)

    def __repr__(self):
        return (
            f'Proxy(id={self.id}, host={self.host}, port={self.port}, '
            f'egress={self.egress}, created_at={self.created_at})'
        )
